self.PINGSERVICE_preaction = function()
{
}

self.PINGSERVICE_onloadaction = function()
{
}

self.PINGSERVICE_enable = function()
{
  document.getElementById('BUTTON_PINGSERVICE_APPLY').disabled = false;
  var ipAddress = document.getElementById('PINGSERVICE_IP_ADDRESS');
  if (ipAddress)
  {
    ipAddress.disabled = false;
  }
  var interval = document.getElementById('PINGSERVICE_INTERVAL');
  if (interval)
  {
    interval.disabled = false;
  } 
}

self.PINGSERVICE_remove = function()
{
  if( !confirm(S['CONFIRM_REMOVE_ADDON']) )
  {
    return;
  }

  var set_url = NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.set_url
                + '?OPERATION=set&command=RemoveAddOn';

  applyChangesAsynch(set_url,  PINGSERVICE_handle_remove_response);
}

self.PINGSERVICE_handle_remove_response = function()
{
  if ( httpAsyncRequestObject && 
      httpAsyncRequestObject.readyState && 
      httpAsyncRequestObject.readyState == 4 ) 
  {
    if ( httpAsyncRequestObject.responseText.indexOf('<payload>') != -1 )
    {
       showProgressBar('default');
       xmlPayLoad  = httpAsyncRequestObject.responseXML;
       var status = xmlPayLoad.getElementsByTagName('status').item(0);
       if (!status || !status.firstChild)
       {
          return;
       }

       if ( status.firstChild.data == 'success')
       {
         display_messages(xmlPayLoad);
         updateAddOn('PINGSERVICE');
         if (!NasState.otherAddOnHash['PINGSERVICE'])
         {
            remove_element('PINGSERVICE');
            if (getNumAddOns() == 0 )
            {
               document.getElementById('no_addons').className = 'visible';
            }
         }
         else
         {
           hide_element('PINGSERVICE_LINK');
         }
       }
       else if (status.firstChild.data == 'failure')
       {
         display_error_messages(xmlPayLoad);
       }
    }
    httpAsyncRequestObject = null;
  }
}

self.PINGSERVICE_page_change = function()
{
  var id_array = new Array('PINGSERVICE_IP_ADDRESS','PINGSERVICE_INTERVAL');
  for (var ix = 0; ix < id_array.length; ix++ )
  {
     NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.fieldHash[id_array[ix]].value = 
     document.getElementById(id_array[ix]).value;
     NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.fieldHash[id_array[ix]].modified = true;
  }
}


self.PINGSERVICE_enable_save_button = function()
{
  document.getElementById('BUTTON_PINGSERVICE_APPLY').disabled = false;
}

self.PINGSERVICE_apply = function()
{

   var page_changed = false;
   var set_url = NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.set_url;
   var ipAddress = document.getElementById('PINGSERVICE_IP_ADDRESS');
  var interval = document.getElementById('PINGSERVICE_INTERVAL');
   if (ipAddress || interval)
   {
     var id_array = new Array ('PINGSERVICE_IP_ADDRESS','PINGSERVICE_INTERVAL');
     for (var ix = 0; ix < id_array.length ; ix ++)
     {
       if (  NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.fieldHash[id_array[ix]].modified )
       {
          page_changed = true;
          break;
       }
     }
   }
   var enabled = document.getElementById('CHECKBOX_PINGSERVICE_ENABLED').checked ? 'checked' :  'unchecked';
   var current_status  = NasState.otherAddOnHash['PINGSERVICE'].Status;
   if ( page_changed )
   {
      set_url += '?command=ModifyAddOnService&OPERATION=set&' + 
                  NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.getApplicablePagePostStringNoQuest('modify') +
                  '&CHECKBOX_PINGSERVICE_ENABLED=' +  enabled;
      if ( enabled == 'checked' && current_status == 'on' ) 
      {
        set_url += "&SWITCH=NO";
      }
      else
      {
         set_url += "&SWITCH=YES";
      }
   }
   else
   {
      set_url += '?command=ToggleService&OPERATION=set&CHECKBOX_PINGSERVICE_ENABLED=' + enabled;
   }
   applyChangesAsynch(set_url, PINGSERVICE_handle_apply_response);
}

self.PINGSERVICE_handle_apply_response = function()
{
  if ( httpAsyncRequestObject &&
       httpAsyncRequestObject.readyState &&
       httpAsyncRequestObject.readyState == 4 )
  {
    if ( httpAsyncRequestObject.responseText.indexOf('<payload>') != -1 )
    {
      showProgressBar('default');
      xmlPayLoad = httpAsyncRequestObject.responseXML;
      var status = xmlPayLoad.getElementsByTagName('status').item(0);
      if ( !status || !status.firstChild )
      {
        return;
      }

      if ( status.firstChild.data == 'success' )
      {
        var log_alert_payload = xmlPayLoad.getElementsByTagName('normal_alerts').item(0);
        if ( log_alert_payload )
	{
	  var messages = grabMessagePayLoad(log_alert_payload);
	  if ( messages && messages.length > 0 )
	  {
	      if ( messages != 'NO_ALERTS' )
	      {
	        alert (messages);
	      }
	      var success_message_start = AS['SUCCESS_ADDON_START'];
		  success_message_start = success_message_start.replace('%ADDON_NAME%', NasState.otherAddOnHash['PINGSERVICE'].FriendlyName);
	      var success_message_stop  = AS['SUCCESS_ADDON_STOP'];
		  success_message_stop = success_message_stop.replace('%ADDON_NAME%', NasState.otherAddOnHash['PINGSERVICE'].FriendlyName);

	      if ( NasState.otherAddOnHash['PINGSERVICE'].Status == 'off' )
	      {
	        NasState.otherAddOnHash['PINGSERVICE'].Status = 'on';
	        NasState.otherAddOnHash['PINGSERVICE'].RunStatus = 'OK';
	        refresh_applicable_pages();
	      }
	      else
	      {
	        NasState.otherAddOnHash['PINGSERVICE'].Status = 'off';
	        NasState.otherAddOnHash['PINGSERVICE'].RunStatus = 'not_present';
	        refresh_applicable_pages();
	      }
	    }
        }
      }
      else if (status.firstChild.data == 'failure')
      {
        display_error_messages(xmlPayLoad);
      }
    }
    httpAsyncRequestObject = null;
  }
}

self.PINGSERVICE_handle_apply_toggle_response = function()
{
  if (httpAsyncRequestObject &&
      httpAsyncRequestObject.readyState &&
      httpAsyncRequestObject.readyState == 4 )
  {
    if ( httpAsyncRequestObject.responseText.indexOf('<payload>') != -1 )
    {
      showProgressBar('default');
      xmlPayLoad = httpAsyncRequestObject.responseXML;
      var status = xmlPayLoad.getElementsByTagName('status').item(0);
      if (!status || !status.firstChild)
      {
        return;
      }
      if ( status.firstChild.data == 'success' )
      {
        display_messages(xmlPayLoad);
      }
      else
      {
        display_error_messages(xmlPayLoad);
      }
    }
  }
}

self.PINGSERVICE_service_toggle = function()
{
  
  var addon_enabled = document.getElementById('CHECKBOX_PINGSERVICE_ENABLED').checked ? 'checked' :  'unchecked';
  var set_url    = NasState.otherAddOnHash['PINGSERVICE'].DisplayAtom.set_url
                   + '?OPERATION=set&command=ToggleService&CHECKBOX_PINGSERVICE_ENABLED='
                   + addon_enabled;
  
  var xmlSyncPayLoad = getXmlFromUrl(set_url);
  var syncStatus = xmlSyncPayLoad.getElementsByTagName('status').item(0);
  if (!syncStatus || !syncStatus.firstChild)
  {
     return ret_val;
  }

  if ( syncStatus.firstChild.data == 'success' )
  {
    display_messages(xmlSyncPayLoad);
    //if PINGSERVICE is enabled
    NasState.otherAddOnHash['PINGSERVICE'].Status = 'on';                                             
    NasState.otherAddOnHash['PINGSERVICE'].RunStatus = 'OK';                                            
    refresh_applicable_pages();  
    //else if PINGSERVICE is disabled
    NasState.otherAddOnHash['PINGSERVICE'].Status = 'off';                    
    NasState.otherAddOnHash['PINGSERVICE'].RunStatus = 'not_present';         
    refresh_applicable_pages(); 
  }
  else
  {
    display_error_messages(xmlSyncPayLoad);
  }
}

